Home

Container Tracking API

version 1

Container Tracking API enables users to identify the current location and movement status of a container anywhere in the world in real time. To retrieve tracking information, simply provide one of the following identifiers:

  • Bill of Lading (B/L) number
  • Container number
  • Booking number

The API returns the latest available container position, shipment milestones, route details, and transportation status across the global logistics network.

OpenAPI Specification

Get started with your API integration in just a few minutes. The OpenAPI specification provides a complete overview of all available endpoints, request parameters, authentication methods, and response formats, allowing you to easily explore, test, and interact with the API.

General information

Container Tracking API is organized around REST.
The API uses predictable resource-based URLs, supports form-encoded request payloads, returns responses in JSON format, and relies on standard HTTP methods, status codes, and authentication mechanisms.

API endpoint#

1https://api.qubictron.com/tracking/v1

All endpoints are only accessible via HTTPS and are located at api.qubictron.com

Track ocean shipment

get/ocean

Returns full tracking information for an ocean freight shipment, including:

  • Shipment status and carrier details
  • All port locations involved in the route
  • Terminal/facility details
  • Transport vessels used
  • Route summary (origin, transshipments, destination)
  • Container-level events with timestamps and locations
Headers

Content-Typeapplication/json

Query Parameters
  • reference_numberREQUIREDstring

    The tracking reference number associated with the shipment. The format depends on the reference_type:

    • For BL: Bill of Lading number (e.g. 255303287)
    • For BOOKING: Carrier booking reference
    • For CONTAINER: Container number (e.g. MSKU7868382)

    Example:255303287

  • carrier_codeOptionalstring

    SCAC (Standard Carrier Alpha Code) of the ocean carrier. Common values:

    • maeu — Maersk
    • mscu — MSC
    • cmdu — CMA CGM
    • cosu — COSCO

    Example:maeu

  • reference_typeOptionalstring

    The type of the reference number provided. Accepted values:

    • bl — Bill of Lading
    • booking — Booking number
    • container — Container number

    Allowed values:blbookingcontainer

    Example:bl

Response example
Shipment tracking data successfully retrieved.
1{
2  "success": true,
3  "status_code": "OK",
4  "meta": {
5    "request": {
6      "params": {
7        "reference_number": "256762772",
8        "reference_type": "BL",
9        "carrier_code": "MAEU"
10      }
11    }
12  },
13  "data": {
14    "shipment": {
15      "reference_type": "BL",
16      "reference_number": "256762772",
17      "carrier": {
18        "code": "MAEU",
19        "name": "Maersk"
20      },
21      "status": "DELIVERED",
22      "updated_at": "2026-05-13T09:31:43+00:00"
23    },
24    "locations": [
25      {
26        "id": 1,
27        "name": "Gdansk",
28        "state": "Wojewodztwo Pomorskie",
29        "country": {
30          "code": "PL",
31          "name": "Poland"
32        },
33        "unlocode": "PLGDN",
34        "coordinates": {
35          "lat": 54.35227,
36          "lng": 18.64912
37        }
38      },
39      {
40        "id": 2,
41        "name": "Jawaharlal Nehru",
42        "state": "State of Maharashtra",
43        "country": {
44          "code": "IN",
45          "name": "India"
46        },
47        "unlocode": "INNSA",
48        "coordinates": {
49          "lat": 18.94977,
50          "lng": 72.95083
51        }
52      },
53      {
54        "id": 3,
55        "name": "Hamburg",
56        "state": "Free and Hanseatic City of Hamburg",
57        "country": {
58          "code": "DE",
59          "name": "Germany"
60        },
61        "unlocode": "DEHAM",
62        "coordinates": {
63          "lat": 53.55073,
64          "lng": 9.99302
65        }
66      },
67      {
68        "id": 4,
69        "name": "Colombo",
70        "state": "Western Province",
71        "country": {
72          "code": "LK",
73          "name": "Sri Lanka"
74        },
75        "unlocode": "LKCMB",
76        "coordinates": {
77          "lat": 6.93548,
78          "lng": 79.84868
79        }
80      },
81      {
82        "id": 5,
83        "name": "Mumbai",
84        "state": "State of Maharashtra",
85        "country": {
86          "code": "IN",
87          "name": "India"
88        },
89        "unlocode": "INBOM",
90        "coordinates": {
91          "lat": 19.07283,
92          "lng": 72.88261
93        }
94      }
95    ],
96    "facilities": [
97      {
98        "id": 1,
99        "name": "Gdansk Baltic HUB Terminal",
100        "country": {
101          "code": "PL",
102          "name": "Poland"
103        },
104        "unlocode": null,
105        "bic_code": null,
106        "smdg_code": null,
107        "coordinates": {
108          "lat": null,
109          "lng": null
110        }
111      },
112      {
113        "id": 2,
114        "name": "Hamburg CT Altenwerder",
115        "country": {
116          "code": "DE",
117          "name": "Germany"
118        },
119        "unlocode": null,
120        "bic_code": null,
121        "smdg_code": null,
122        "coordinates": {
123          "lat": null,
124          "lng": null
125        }
126      },
127      {
128        "id": 3,
129        "name": "South Asia Gateway Terminals",
130        "country": {
131          "code": "LK",
132          "name": "Sri Lanka"
133        },
134        "unlocode": "LKCMB",
135        "bic_code": null,
136        "smdg_code": null,
137        "coordinates": {
138          "lat": null,
139          "lng": null
140        }
141      },
142      {
143        "id": 4,
144        "name": "Bharat Mumbai Container Terminal",
145        "country": {
146          "code": "IN",
147          "name": "India"
148        },
149        "unlocode": "INNSA",
150        "bic_code": null,
151        "smdg_code": null,
152        "coordinates": {
153          "lat": 18.933333,
154          "lng": 72.933333
155        }
156      },
157      {
158        "id": 5,
159        "name": "Foxal Yard",
160        "country": {
161          "code": "IN",
162          "name": "India"
163        },
164        "unlocode": null,
165        "bic_code": null,
166        "smdg_code": null,
167        "coordinates": {
168          "lat": null,
169          "lng": null
170        }
171      }
172    ],
173    "transports": [
174      {
175        "id": 1,
176        "type": "VESSEL",
177        "name": "MAERSK CHAMBAL",
178        "imo": 9525376,
179        "call_sign": "VRJT5",
180        "mmsi": 477083800,
181        "flag": "HK"
182      },
183      {
184        "id": 2,
185        "type": "VESSEL",
186        "name": "MAERSK SEOUL",
187        "imo": 9306550,
188        "call_sign": "9V5632",
189        "mmsi": 563032900,
190        "flag": "SG"
191      },
192      {
193        "id": 3,
194        "type": "VESSEL",
195        "name": "MAERSK CONAKRY",
196        "imo": 9525285,
197        "call_sign": "9V9267",
198        "mmsi": 564305000,
199        "flag": "SG"
200      }
201    ],
202    "route": {
203      "place_of_receipt": {
204        "location_id": 1
205      },
206      "first_port_of_loading": {
207        "location_id": 1,
208        "departure": {
209          "datetime": "2025-07-31T00:01:00+02:00",
210          "is_actual": true,
211          "facility_id": 1,
212          "transport_mode": "VESSEL",
213          "transport_id": 1,
214          "voyage_number": "531S"
215        }
216      },
217      "transshipments": [
218        {
219          "location_id": 3,
220          "arrival": {
221            "datetime": "2025-08-06T14:55:00+02:00",
222            "is_actual": true,
223            "facility_id": 2,
224            "transport_mode": "VESSEL",
225            "transport_id": 1,
226            "voyage_number": "531S"
227          },
228          "departure": {
229            "datetime": "2025-08-09T14:36:00+02:00",
230            "is_actual": true,
231            "facility_id": 2,
232            "transport_mode": "VESSEL",
233            "transport_id": 2,
234            "voyage_number": "532E"
235          }
236        },
237        {
238          "location_id": 4,
239          "arrival": {
240            "datetime": "2025-09-09T15:59:00+05:30",
241            "is_actual": true,
242            "facility_id": 3,
243            "transport_mode": "VESSEL",
244            "transport_id": 2,
245            "voyage_number": "532E"
246          },
247          "departure": {
248            "datetime": "2025-09-14T13:54:00+05:30",
249            "is_actual": true,
250            "facility_id": 3,
251            "transport_mode": "VESSEL",
252            "transport_id": 3,
253            "voyage_number": "533E"
254          }
255        }
256      ],
257      "final_port_of_discharge": {
258        "location_id": 2,
259        "arrival": {
260          "datetime": "2025-09-18T17:18:00+05:30",
261          "is_actual": true,
262          "facility_id": 4,
263          "transport_mode": "VESSEL",
264          "transport_id": 3,
265          "voyage_number": "533E"
266        }
267      },
268      "place_of_delivery": {
269        "location_id": 2
270      }
271    },
272    "containers": [
273      {
274        "number": "CAAU6629941",
275        "size": 40,
276        "type": "High Cube Dry",
277        "iso_code": "45G1",
278        "status": "DELIVERED",
279        "events": [
280          {
281            "sequence": 1,
282            "description": "Gate in",
283            "datetime": "2025-07-25T06:13:00+02:00",
284            "is_actual": true,
285            "location_id": 1,
286            "location_type": "FIRST_PORT_OF_LOADING",
287            "facility_id": 1,
288            "transport_mode": "TRUCK",
289            "transport_id": null,
290            "voyage_number": null,
291            "type": "EQUIPMENT",
292            "event_code": "GTIN",
293            "empty_indicator": "FULL"
294          },
295          {
296            "sequence": 2,
297            "description": "Load",
298            "datetime": "2025-07-30T04:03:00+02:00",
299            "is_actual": true,
300            "location_id": 1,
301            "location_type": "FIRST_PORT_OF_LOADING",
302            "facility_id": 1,
303            "transport_mode": "VESSEL",
304            "transport_id": 1,
305            "voyage_number": "531S",
306            "type": "EQUIPMENT",
307            "event_code": "LOAD",
308            "empty_indicator": "FULL"
309          },
310          {
311            "sequence": 3,
312            "description": "Vessel departure",
313            "datetime": "2025-07-31T00:01:00+02:00",
314            "is_actual": true,
315            "location_id": 1,
316            "location_type": "FIRST_PORT_OF_LOADING",
317            "facility_id": 1,
318            "transport_mode": "VESSEL",
319            "transport_id": 1,
320            "voyage_number": "531S",
321            "type": "TRANSPORT",
322            "event_code": "DEPA",
323            "empty_indicator": "FULL"
324          },
325          {
326            "sequence": 4,
327            "description": "Vessel arrival",
328            "datetime": "2025-08-06T14:55:00+02:00",
329            "is_actual": true,
330            "location_id": 3,
331            "location_type": "TRANSSHIPMENT_PORT",
332            "facility_id": 2,
333            "transport_mode": "VESSEL",
334            "transport_id": 1,
335            "voyage_number": "531S",
336            "type": "TRANSPORT",
337            "event_code": "ARRI",
338            "empty_indicator": "FULL"
339          },
340          {
341            "sequence": 5,
342            "description": "Discharge",
343            "datetime": "2025-08-06T20:18:00+02:00",
344            "is_actual": true,
345            "location_id": 3,
346            "location_type": "TRANSSHIPMENT_PORT",
347            "facility_id": 2,
348            "transport_mode": "VESSEL",
349            "transport_id": 1,
350            "voyage_number": "531S",
351            "type": "EQUIPMENT",
352            "event_code": "DISC",
353            "empty_indicator": "FULL"
354          },
355          {
356            "sequence": 6,
357            "description": "Load",
358            "datetime": "2025-08-08T14:27:00+02:00",
359            "is_actual": true,
360            "location_id": 3,
361            "location_type": "TRANSSHIPMENT_PORT",
362            "facility_id": 2,
363            "transport_mode": "VESSEL",
364            "transport_id": 2,
365            "voyage_number": "532E",
366            "type": "EQUIPMENT",
367            "event_code": "LOAD",
368            "empty_indicator": "FULL"
369          },
370          {
371            "sequence": 7,
372            "description": "Vessel departure",
373            "datetime": "2025-08-09T14:36:00+02:00",
374            "is_actual": true,
375            "location_id": 3,
376            "location_type": "TRANSSHIPMENT_PORT",
377            "facility_id": 2,
378            "transport_mode": "VESSEL",
379            "transport_id": 2,
380            "voyage_number": "532E",
381            "type": "TRANSPORT",
382            "event_code": "DEPA",
383            "empty_indicator": "FULL"
384          },
385          {
386            "sequence": 8,
387            "description": "Vessel arrival",
388            "datetime": "2025-09-09T15:59:00+05:30",
389            "is_actual": true,
390            "location_id": 4,
391            "location_type": "TRANSSHIPMENT_PORT",
392            "facility_id": 3,
393            "transport_mode": "VESSEL",
394            "transport_id": 2,
395            "voyage_number": "532E",
396            "type": "TRANSPORT",
397            "event_code": "ARRI",
398            "empty_indicator": "FULL"
399          },
400          {
401            "sequence": 9,
402            "description": "Discharge",
403            "datetime": "2025-09-09T20:06:00+05:30",
404            "is_actual": true,
405            "location_id": 4,
406            "location_type": "TRANSSHIPMENT_PORT",
407            "facility_id": 3,
408            "transport_mode": "VESSEL",
409            "transport_id": 2,
410            "voyage_number": "532E",
411            "type": "EQUIPMENT",
412            "event_code": "DISC",
413            "empty_indicator": "FULL"
414          },
415          {
416            "sequence": 10,
417            "description": "Load",
418            "datetime": "2025-09-14T06:39:00+05:30",
419            "is_actual": true,
420            "location_id": 4,
421            "location_type": "TRANSSHIPMENT_PORT",
422            "facility_id": 3,
423            "transport_mode": "VESSEL",
424            "transport_id": 3,
425            "voyage_number": "533E",
426            "type": "EQUIPMENT",
427            "event_code": "LOAD",
428            "empty_indicator": "FULL"
429          },
430          {
431            "sequence": 11,
432            "description": "Vessel departure",
433            "datetime": "2025-09-14T13:54:00+05:30",
434            "is_actual": true,
435            "location_id": 4,
436            "location_type": "TRANSSHIPMENT_PORT",
437            "facility_id": 3,
438            "transport_mode": "VESSEL",
439            "transport_id": 3,
440            "voyage_number": "533E",
441            "type": "TRANSPORT",
442            "event_code": "DEPA",
443            "empty_indicator": "FULL"
444          },
445          {
446            "sequence": 12,
447            "description": "Vessel arrival",
448            "datetime": "2025-09-18T17:18:00+05:30",
449            "is_actual": true,
450            "location_id": 2,
451            "location_type": "FINAL_PORT_OF_DISCHARGE",
452            "facility_id": 4,
453            "transport_mode": "VESSEL",
454            "transport_id": 3,
455            "voyage_number": "533E",
456            "type": "TRANSPORT",
457            "event_code": "ARRI",
458            "empty_indicator": "FULL"
459          },
460          {
461            "sequence": 13,
462            "description": "Discharge",
463            "datetime": "2025-09-19T01:06:00+05:30",
464            "is_actual": true,
465            "location_id": 2,
466            "location_type": "FINAL_PORT_OF_DISCHARGE",
467            "facility_id": 4,
468            "transport_mode": "VESSEL",
469            "transport_id": 3,
470            "voyage_number": "533E",
471            "type": "EQUIPMENT",
472            "event_code": "DISC",
473            "empty_indicator": "FULL"
474          },
475          {
476            "sequence": 14,
477            "description": "Gate out",
478            "datetime": "2025-09-19T14:40:00+05:30",
479            "is_actual": true,
480            "location_id": 2,
481            "location_type": "FINAL_PORT_OF_DISCHARGE",
482            "facility_id": 4,
483            "transport_mode": "TRUCK",
484            "transport_id": null,
485            "voyage_number": null,
486            "type": "EQUIPMENT",
487            "event_code": "GTOT",
488            "empty_indicator": "FULL"
489          },
490          {
491            "sequence": 15,
492            "description": "Empty container return",
493            "datetime": "2025-09-25T11:07:00+05:30",
494            "is_actual": true,
495            "location_id": 5,
496            "location_type": "DEPOT",
497            "facility_id": 5,
498            "transport_mode": "TRUCK",
499            "transport_id": null,
500            "voyage_number": null,
501            "type": "EQUIPMENT",
502            "event_code": "GTIN",
503            "empty_indicator": "EMPTY"
504          }
505        ]
506      },
507      {
508        "number": "MRSU7177421",
509        "size": 40,
510        "type": "High Cube Dry",
511        "iso_code": "45G1",
512        "status": "DELIVERED",
513        "events": [
514          {
515            "sequence": 1,
516            "description": "Gate in",
517            "datetime": "2025-07-24T11:16:00+02:00",
518            "is_actual": true,
519            "location_id": 1,
520            "location_type": "FIRST_PORT_OF_LOADING",
521            "facility_id": 1,
522            "transport_mode": "TRUCK",
523            "transport_id": null,
524            "voyage_number": null,
525            "type": "EQUIPMENT",
526            "event_code": "GTIN",
527            "empty_indicator": "FULL"
528          },
529          {
530            "sequence": 2,
531            "description": "Load",
532            "datetime": "2025-07-30T04:01:00+02:00",
533            "is_actual": true,
534            "location_id": 1,
535            "location_type": "FIRST_PORT_OF_LOADING",
536            "facility_id": 1,
537            "transport_mode": "VESSEL",
538            "transport_id": 1,
539            "voyage_number": "531S",
540            "type": "EQUIPMENT",
541            "event_code": "LOAD",
542            "empty_indicator": "FULL"
543          },
544          {
545            "sequence": 3,
546            "description": "Vessel departure",
547            "datetime": "2025-07-31T00:01:00+02:00",
548            "is_actual": true,
549            "location_id": 1,
550            "location_type": "FIRST_PORT_OF_LOADING",
551            "facility_id": 1,
552            "transport_mode": "VESSEL",
553            "transport_id": 1,
554            "voyage_number": "531S",
555            "type": "TRANSPORT",
556            "event_code": "DEPA",
557            "empty_indicator": "FULL"
558          },
559          {
560            "sequence": 4,
561            "description": "Vessel arrival",
562            "datetime": "2025-08-06T14:55:00+02:00",
563            "is_actual": true,
564            "location_id": 3,
565            "location_type": "TRANSSHIPMENT_PORT",
566            "facility_id": 2,
567            "transport_mode": "VESSEL",
568            "transport_id": 1,
569            "voyage_number": "531S",
570            "type": "TRANSPORT",
571            "event_code": "ARRI",
572            "empty_indicator": "FULL"
573          },
574          {
575            "sequence": 5,
576            "description": "Discharge",
577            "datetime": "2025-08-06T20:29:00+02:00",
578            "is_actual": true,
579            "location_id": 3,
580            "location_type": "TRANSSHIPMENT_PORT",
581            "facility_id": 2,
582            "transport_mode": "VESSEL",
583            "transport_id": 1,
584            "voyage_number": "531S",
585            "type": "EQUIPMENT",
586            "event_code": "DISC",
587            "empty_indicator": "FULL"
588          },
589          {
590            "sequence": 6,
591            "description": "Load",
592            "datetime": "2025-08-08T14:24:00+02:00",
593            "is_actual": true,
594            "location_id": 3,
595            "location_type": "TRANSSHIPMENT_PORT",
596            "facility_id": 2,
597            "transport_mode": "VESSEL",
598            "transport_id": 2,
599            "voyage_number": "532E",
600            "type": "EQUIPMENT",
601            "event_code": "LOAD",
602            "empty_indicator": "FULL"
603          },
604          {
605            "sequence": 7,
606            "description": "Vessel departure",
607            "datetime": "2025-08-09T14:36:00+02:00",
608            "is_actual": true,
609            "location_id": 3,
610            "location_type": "TRANSSHIPMENT_PORT",
611            "facility_id": 2,
612            "transport_mode": "VESSEL",
613            "transport_id": 2,
614            "voyage_number": "532E",
615            "type": "TRANSPORT",
616            "event_code": "DEPA",
617            "empty_indicator": "FULL"
618          },
619          {
620            "sequence": 8,
621            "description": "Vessel arrival",
622            "datetime": "2025-09-09T15:59:00+05:30",
623            "is_actual": true,
624            "location_id": 4,
625            "location_type": "TRANSSHIPMENT_PORT",
626            "facility_id": 3,
627            "transport_mode": "VESSEL",
628            "transport_id": 2,
629            "voyage_number": "532E",
630            "type": "TRANSPORT",
631            "event_code": "ARRI",
632            "empty_indicator": "FULL"
633          },
634          {
635            "sequence": 9,
636            "description": "Discharge",
637            "datetime": "2025-09-09T19:50:00+05:30",
638            "is_actual": true,
639            "location_id": 4,
640            "location_type": "TRANSSHIPMENT_PORT",
641            "facility_id": 3,
642            "transport_mode": "VESSEL",
643            "transport_id": 2,
644            "voyage_number": "532E",
645            "type": "EQUIPMENT",
646            "event_code": "DISC",
647            "empty_indicator": "FULL"
648          },
649          {
650            "sequence": 10,
651            "description": "Load",
652            "datetime": "2025-09-14T06:51:00+05:30",
653            "is_actual": true,
654            "location_id": 4,
655            "location_type": "TRANSSHIPMENT_PORT",
656            "facility_id": 3,
657            "transport_mode": "VESSEL",
658            "transport_id": 3,
659            "voyage_number": "533E",
660            "type": "EQUIPMENT",
661            "event_code": "LOAD",
662            "empty_indicator": "FULL"
663          },
664          {
665            "sequence": 11,
666            "description": "Vessel departure",
667            "datetime": "2025-09-14T13:54:00+05:30",
668            "is_actual": true,
669            "location_id": 4,
670            "location_type": "TRANSSHIPMENT_PORT",
671            "facility_id": 3,
672            "transport_mode": "VESSEL",
673            "transport_id": 3,
674            "voyage_number": "533E",
675            "type": "TRANSPORT",
676            "event_code": "DEPA",
677            "empty_indicator": "FULL"
678          },
679          {
680            "sequence": 12,
681            "description": "Vessel arrival",
682            "datetime": "2025-09-18T17:18:00+05:30",
683            "is_actual": true,
684            "location_id": 2,
685            "location_type": "FINAL_PORT_OF_DISCHARGE",
686            "facility_id": 4,
687            "transport_mode": "VESSEL",
688            "transport_id": 3,
689            "voyage_number": "533E",
690            "type": "TRANSPORT",
691            "event_code": "ARRI",
692            "empty_indicator": "FULL"
693          },
694          {
695            "sequence": 13,
696            "description": "Discharge",
697            "datetime": "2025-09-19T00:04:00+05:30",
698            "is_actual": true,
699            "location_id": 2,
700            "location_type": "FINAL_PORT_OF_DISCHARGE",
701            "facility_id": 4,
702            "transport_mode": "VESSEL",
703            "transport_id": 3,
704            "voyage_number": "533E",
705            "type": "EQUIPMENT",
706            "event_code": "DISC",
707            "empty_indicator": "FULL"
708          },
709          {
710            "sequence": 14,
711            "description": "Gate out",
712            "datetime": "2025-09-21T07:31:00+05:30",
713            "is_actual": true,
714            "location_id": 2,
715            "location_type": "FINAL_PORT_OF_DISCHARGE",
716            "facility_id": 4,
717            "transport_mode": "TRUCK",
718            "transport_id": null,
719            "voyage_number": null,
720            "type": "EQUIPMENT",
721            "event_code": "GTOT",
722            "empty_indicator": "FULL"
723          },
724          {
725            "sequence": 15,
726            "description": "Empty container return",
727            "datetime": "2025-09-25T18:58:00+05:30",
728            "is_actual": true,
729            "location_id": 5,
730            "location_type": "DEPOT",
731            "facility_id": 5,
732            "transport_mode": "TRUCK",
733            "transport_id": null,
734            "voyage_number": null,
735            "type": "EQUIPMENT",
736            "event_code": "GTIN",
737            "empty_indicator": "EMPTY"
738          }
739        ]
740      }
741    ]
742  }
743}

Get list of supported carriers

get/ocean/carriers

Returns the full list of ocean carriers supported by the tracking API, along with their identifiers, current availability status, and supported tracking reference types.

Headers

Content-Typeapplication/json

Response example
List of supported carriers successfully retrieved.

Qubictron 2026Contact us